/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-iai-control-msgs-0.0.5-0raring-20150424-1743/msg/MultiJointVelocityImpedanceCommand.msg
 *
 */


#ifndef IAI_CONTROL_MSGS_MESSAGE_MULTIJOINTVELOCITYIMPEDANCECOMMAND_H
#define IAI_CONTROL_MSGS_MESSAGE_MULTIJOINTVELOCITYIMPEDANCECOMMAND_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace iai_control_msgs
{
template <class ContainerAllocator>
struct MultiJointVelocityImpedanceCommand_
{
  typedef MultiJointVelocityImpedanceCommand_<ContainerAllocator> Type;

  MultiJointVelocityImpedanceCommand_()
    : header()
    , velocity()
    , stiffness()
    , damping()
    , add_torque()  {
    }
  MultiJointVelocityImpedanceCommand_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , velocity(_alloc)
    , stiffness(_alloc)
    , damping(_alloc)
    , add_torque(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _velocity_type;
  _velocity_type velocity;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _stiffness_type;
  _stiffness_type stiffness;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _damping_type;
  _damping_type damping;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _add_torque_type;
  _add_torque_type add_torque;




  typedef boost::shared_ptr< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct MultiJointVelocityImpedanceCommand_

typedef ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<std::allocator<void> > MultiJointVelocityImpedanceCommand;

typedef boost::shared_ptr< ::iai_control_msgs::MultiJointVelocityImpedanceCommand > MultiJointVelocityImpedanceCommandPtr;
typedef boost::shared_ptr< ::iai_control_msgs::MultiJointVelocityImpedanceCommand const> MultiJointVelocityImpedanceCommandConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace iai_control_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'iai_control_msgs': ['/tmp/buildd/ros-hydro-iai-control-msgs-0.0.5-0raring-20150424-1743/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d4747ea02611dd2a7cda90f6dce148aa";
  }

  static const char* value(const ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd4747ea02611dd2aULL;
  static const uint64_t static_value2 = 0x7cda90f6dce148aaULL;
};

template<class ContainerAllocator>
struct DataType< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "iai_control_msgs/MultiJointVelocityImpedanceCommand";
  }

  static const char* value(const ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#Header\n\
Header header\n\
\n\
# Command to move a set of velocity-resolved robot joints \n\
float32[] velocity     #joint velocity in rad/s\n\
float32[] stiffness    #joint stiffness in Nm/rad\n\
float32[] damping      #joint damping (normalized, 0.7 is critically dampped)\n\
\n\
# Experimental field: DO NOT USE unless you really know what you are doing!\n\
float32[] add_torque   #additional joint torque in Nm\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.velocity);
      stream.next(m.stiffness);
      stream.next(m.damping);
      stream.next(m.add_torque);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct MultiJointVelocityImpedanceCommand_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::iai_control_msgs::MultiJointVelocityImpedanceCommand_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "velocity[]" << std::endl;
    for (size_t i = 0; i < v.velocity.size(); ++i)
    {
      s << indent << "  velocity[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.velocity[i]);
    }
    s << indent << "stiffness[]" << std::endl;
    for (size_t i = 0; i < v.stiffness.size(); ++i)
    {
      s << indent << "  stiffness[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.stiffness[i]);
    }
    s << indent << "damping[]" << std::endl;
    for (size_t i = 0; i < v.damping.size(); ++i)
    {
      s << indent << "  damping[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.damping[i]);
    }
    s << indent << "add_torque[]" << std::endl;
    for (size_t i = 0; i < v.add_torque.size(); ++i)
    {
      s << indent << "  add_torque[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.add_torque[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // IAI_CONTROL_MSGS_MESSAGE_MULTIJOINTVELOCITYIMPEDANCECOMMAND_H
